<?php

namespace Lc\CaracoleBundle\Controller\Reminder;

use App\Entity\Reminder\Reminder;
use Lc\CaracoleBundle\Controller\AdminControllerTrait;
use Lc\CaracoleBundle\Factory\Reminder\ReminderFactory;
use Lc\CaracoleBundle\Resolver\MerchantResolver;
use Lc\CaracoleBundle\Resolver\SectionResolver;
use Lc\SovBundle\Container\Reminder\ReminderContainer;
use Lc\SovBundle\Controller\Reminder\ReminderAdminController as SovReminderAdminController;

class ReminderAdminController extends SovReminderAdminController
{
    use AdminControllerTrait;

    public function createEntity(string $crudAction = null, string $crudControllerFqcn = null, int $entityId = null)
    {
        return $this->get(ReminderContainer::class)
                ->getFactory()
                ->setMerchant($this->get(MerchantResolver::class)->getCurrent())
                ->setSection($this->get(SectionResolver::class)->getCurrent())
                ->create($crudAction, $crudControllerFqcn, $entityId);
    }
}
