<?php

namespace Lc\CaracoleBundle\Model\Site;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Doctrine\Extension\FilterSectionInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Model\Site\PageModel as SovPageModel;

/**
 * @ORM\MappedSuperclass()
 */
abstract class PageModel extends SovPageModel implements FilterSectionInterface
{

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface", inversedBy="pages")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $section;

    public function getSection(): SectionInterface
    {
        return $this->section;
    }

    public function setSection(SectionInterface $section): self
    {
        $this->section = $section;

        return $this;
    }

}
